# Taffy: Convention-Over-Configuration REST framework for ColdFusion and Railo

Taffy is a ColdFusion framework that helps you build RESTful web services with very little boilerplate code, very little configuration and very little effort.

## Build Status

[![Taffy Build Status](http://fusiongrokker.com:8080/job/Taffy/badge/icon)](http://fusiongrokker.com:8080/job/Taffy/)

Taffy has a comprehensive test suite and uses continuous integration to ensure that the code is always usable. If you'd like, you can [review the Jenkins build history for Taffy](http://fusiongrokker.com:8080/job/Taffy/).

## Supported Versions

* Taffy 1.3.x
* Taffy 1.2.x

If you file a bug or ask for support, usually our first question is "What version of Taffy are you using?" If it's an older release, we usually ask you to upgrade. Officially, we promise to support the current "minor" release and the prior "minor" release. When Taffy 2.0 is released, it and the preceding "minor" release (e.g. Taffy 1.4.x, if such a thing were to exist) would be supported.

Supported versions get priority for bug fixes; and we make no promise to fix bugs filed against "unsupported" versions. If your version is supported, and your bug is reproducible and isolatable, we'll do everything within our power to address it.

If upgrade is not an option in your case, and you still have an isolatable and reproducable bug, [contact me](http://fusiongrokker.com/page/contact-me) to discuss further options.

## Documentation

Documentation is provided via the wiki, and [here's a nice clean index of what's in the wiki][3].

### You can contribute to the documentation

If you would like to contribute to documentation, [please read this blog post][2]. If you still have questions, [ask them on our mailing list][1]. :)

## Roadmap

In addition to the issues list, Taffy uses a [public trello board](https://trello.com/b/Nz5nyqZg/) to track and plan the framework roadmap.

[![Taffy Roadmap](https://trello.com/b/Nz5nyqZg.png)](https://trello.com/b/Nz5nyqZg/)

## Community

We have [a mailing list for Taffy Users][1]. Feel free to ask for help, discuss potential bugs, and share new ideas there.

I also frequent the #ColdFusion channels on both Freenode and DALNet (IRC).

## Open Source!

Part of the beauty of open source is that _you can affect change_. You can help improve the documentation, fix a bug, add tests, or even propose new features. Nothing is off limits, and I try to be very responsive to pull requests and on the mailing list.

## LICENSE

>**The MIT License (MIT)**
>
>Copyright (c) 2011 Adam Tuttle and Contributors
>
>Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
>
>The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
>
>THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

**What does that mean?**

It means you can use Taffy pretty much any way you like. You can fork it. You can include it in a proprietary product, sell it, and not give us a dime. Pretty much the only thing you can't do is hold us accountable if anything goes wrong.

[1]:https://groups.google.com/forum/#!forum/taffy-users
[2]:http://fusiongrokker.com/post/how-you-can-contribute-to-taffy-documentation
[3]:http://atuttle.github.com/Taffy/documentation.html
